diff --git a/base/deploy/src/pkispawn b/base/deploy/src/pkispawn
index 66152a3..931b9ba 100755
--- a/base/deploy/src/pkispawn
+++ b/base/deploy/src/pkispawn
@@ -34,6 +34,7 @@ try:
     import socket
     import string
     import struct
+    import subprocess
     import time
     from time import strftime as date
     from pki.deployment import pkiconfig as config
@@ -74,7 +75,18 @@ def main(argv):
     config.pki_architecture = struct.calcsize("P") * 8
 
     # Retrieve hostname
-    config.pki_hostname = socket.gethostname()
+    config.pki_hostname = socket.getfqdn()
+
+    # Retrieve DNS domainname
+    config.pki_dns_domainname = None
+    try:
+        config.pki_dns_domainname = subprocess.check_output("domainname",
+                                                            shell=True)
+        config.pki_dns_domainname = config.pki_dns_domainname.rstrip('\n')
+    except subprocess.CalledProcessError as exc:
+        config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        sys.exit(1)
 
     # Generate random 'pin's for use as security database passwords
     pin_low  = 100000000000
@@ -140,6 +152,15 @@ def main(argv):
                              extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     else:
+        # NEVER print out 'sensitive' name/value pairs!!!
+        config.pki_log.debug(log.PKI_DICTIONARY_MANDATORY,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_mandatory_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_OPTIONAL,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_optional_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
                              extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.debug(pp.pformat(config.pki_common_dict),
@@ -155,7 +176,7 @@ def main(argv):
 
     # Override PKI configuration file values with 'custom' command-line values.
     if not config.custom_pki_admin_domain_name is None:
-        config.pki_common_dict['pki_admin_domain_name'] =\
+        config.pki_optional_dict['pki_admin_domain_name'] =\
             config.custom_pki_admin_domain_name
     if not config.custom_pki_instance_name is None:
         config.pki_web_server_dict['pki_instance_name'] =\
@@ -169,6 +190,15 @@ def main(argv):
     if not config.custom_pki_ajp_port is None:
         config.pki_web_server_dict['pki_ajp_port'] =\
             config.custom_pki_ajp_port
+    # NEVER print out 'sensitive' name/value pairs!!!
+    config.pki_log.debug(log.PKI_DICTIONARY_MANDATORY,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_mandatory_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_OPTIONAL,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_optional_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
     config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
                          extra=config.PKI_INDENTATION_LEVEL_0)
     config.pki_log.debug(pp.pformat(config.pki_common_dict),
diff --git a/base/deploy/src/scriptlets/configuration.jy b/base/deploy/src/scriptlets/configuration.jy
index f7366c7..a40e7c6 100644
--- a/base/deploy/src/scriptlets/configuration.jy
+++ b/base/deploy/src/scriptlets/configuration.jy
@@ -9,7 +9,6 @@ import sys
 # PKI Python Imports
 import pkijython as jyutil
 import pkiconfig as config
-from pkiconfig import pki_master_jython_dict as master
 import pkimessages as log
 
 
@@ -18,12 +17,19 @@ from java.lang import System as javasystem
 
 
 def main(argv):
+    rv = 0
+
     # Establish 'master' as the PKI jython dictionary
     master = dict()
 
-    # import the master dictionary from 'pkispawn'
+    # Import the master dictionary from 'pkispawn'
     master = pickle.loads(argv[1])
 
+    # Optionally enable a java debugger (e. g. - 'eclipse'):
+    if config.str2bool(master['pki_enable_java_debugger']):
+        config.wait_to_attach_an_external_java_debugger()
+
+
     # IMPORTANT:  Unfortunately, 'jython 2.2' does NOT support logging!
     #
     #             Until, and unless, 'jython 2.5' or later is used,
@@ -59,11 +65,107 @@ def main(argv):
         master['pki_jython_log_level'])
 
     # Log into token
-    jyutil.security_databases.log_into_token(
-        master['pki_client_database_path'],
-        master['pki_client_password_conf'],
-        master['pki_dry_run_flag'],
-        master['pki_jython_log_level'])
+    token = jyutil.security_databases.log_into_token(
+                master['pki_client_database_path'],
+                master['pki_client_password_conf'],
+                master['pki_dry_run_flag'],
+                master['pki_jython_log_level'])
+
+    # Establish REST Client
+    client = jyutil.rest_client.initialize(
+                 master['pki_jython_base_uri'],
+                 master['pki_dry_run_flag'],
+                 master['pki_jython_log_level'])
+
+    # Construct PKI Subsystem Configuration Data
+    data = None
+    if master['pki_instance_type'] == "Apache":
+        if master['pki_subsystem'] == "RA":
+            print "%s '%s' %s" %\
+                  (log.PKI_JYTHON_INDENTATION_2,
+                   master['pki_subsystem'],
+                   log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+            return self.rv
+        elif master['pki_subsystem'] == "TPS":
+            print "%s '%s' %s" %\
+                  (log.PKI_JYTHON_INDENTATION_2,
+                   master['pki_subsystem'],
+                   log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+            return self.rv
+    elif master['pki_instance_type'] == "Tomcat":
+        if master['pki_subsystem'] == "CA":
+            if config.str2bool(master['pki_clone']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_CLONED_PKI_SUBSYSTEM,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            elif config.str2bool(master['pki_external']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_EXTERNAL_CA,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            elif config.str2bool(master['pki_subordinate']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_SUBORDINATE_CA,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            else:
+                data = jyutil.rest_client.construct_pki_configuration_data(
+                           master, token)
+        elif master['pki_subsystem'] == "KRA":
+            if config.str2bool(master['pki_clone']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_CLONED_PKI_SUBSYSTEM,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            else:
+                print "%s '%s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+        elif master['pki_subsystem'] == "OCSP":
+            if config.str2bool(master['pki_clone']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_CLONED_PKI_SUBSYSTEM,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            else:
+                print "%s '%s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+        elif master['pki_subsystem'] == "TKS":
+            if config.str2bool(master['pki_clone']):
+                print "%s '%s %s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       log.PKI_JYTHON_CLONED_PKI_SUBSYSTEM,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+            else:
+                print "%s '%s' %s" %\
+                      (log.PKI_JYTHON_INDENTATION_2,
+                       master['pki_subsystem'],
+                       log.PKI_JYTHON_NOT_YET_IMPLEMENTED)
+                return self.rv
+
+    # Formulate PKI Subsystem Configuration Data Response
+    jyutil.rest_client.configure_pki_data(data,
+                                          master['pki_subsystem'],
+                                          master['pki_dry_run_flag'],
+                                          master['pki_jython_log_level'])
 
 
 if __name__ == "__main__":
diff --git a/base/deploy/src/scriptlets/configuration.py b/base/deploy/src/scriptlets/configuration.py
index f405739..421e08d 100644
--- a/base/deploy/src/scriptlets/configuration.py
+++ b/base/deploy/src/scriptlets/configuration.py
@@ -36,9 +36,13 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
         if not config.pki_dry_run_flag:
             util.directory.create(master['pki_client_path'], uid=0, gid=0)
+            # Since 'certutil' does NOT strip the 'token=' portion of
+            # the 'token=password' entries, create a client password file
+            # which ONLY contains the 'password' for the purposes of
+            # allowing 'certutil' to generate the security databases
             util.password.create_password_conf(
                 master['pki_client_password_conf'],
-                master['pki_client_pin'])
+                master['pki_client_pin'], pin_sans_token=True)
             util.directory.create(master['pki_client_database_path'],
                                   uid=0, gid=0)
             util.certutil.create_security_databases(
@@ -47,19 +51,60 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 master['pki_client_key_database'],
                 master['pki_client_secmod_database'],
                 password_file=master['pki_client_password_conf'])
-            util.symlink.create(
-                config.pki_master_dict['pki_systemd_service'],
-                config.pki_master_dict['pki_systemd_service_link'])
+            util.symlink.create(master['pki_systemd_service'],
+                                master['pki_systemd_service_link'])
         else:
+            # Since 'certutil' does NOT strip the 'token=' portion of
+            # the 'token=password' entries, create a client password file
+            # which ONLY contains the 'password' for the purposes of
+            # allowing 'certutil' to generate the security databases
             util.password.create_password_conf(
                 master['pki_client_password_conf'],
-                master['pki_client_pin'])
+                master['pki_client_pin'], pin_sans_token=True)
             util.certutil.create_security_databases(
                 master['pki_client_database_path'],
                 master['pki_client_cert_database'],
                 master['pki_client_key_database'],
                 master['pki_client_secmod_database'],
                 password_file=master['pki_client_password_conf'])
+        # Start/Restart this Apache/Tomcat PKI Process
+        if not config.pki_dry_run_flag:
+            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+                apache_instances = util.instance.apache_instances()
+                if apache_instances == 1:
+                    util.systemd.start()
+                elif apache_instances > 1:
+                    util.systemd.restart()
+            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                # Optionally prepare to enable a java debugger
+                # (e. g. - 'eclipse'):
+                if config.str2bool(master['pki_enable_java_debugger']):
+                    config.prepare_for_an_external_java_debugger(
+                        master['pki_target_tomcat_conf_instance_id'])
+                tomcat_instances = util.instance.tomcat_instances()
+                if tomcat_instances == 1:
+                    util.systemd.start()
+                elif tomcat_instances > 1:
+                    util.systemd.restart()
+        else:
+            # ALWAYS display correct information (even during dry_run)
+            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+                apache_instances = util.instance.apache_instances()
+                if apache_instances == 0:
+                    util.systemd.start()
+                elif apache_instances > 0:
+                    util.systemd.restart()
+            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                # Optionally prepare to enable a java debugger
+                # (e. g. - 'eclipse'):
+                if config.str2bool(master['pki_enable_java_debugger']):
+                    config.prepare_for_an_external_java_debugger(
+                        master['pki_target_tomcat_conf_instance_id'])
+                tomcat_instances = util.instance.tomcat_instances()
+                if tomcat_instances == 0:
+                    util.systemd.start()
+                elif tomcat_instances > 0:
+                    util.systemd.restart()
         # Pass control to the Java servlet via Jython 2.2 'configuration.jy'
         util.jython.invoke(master['pki_jython_configuration_scriptlet'])
         return self.rv
@@ -67,6 +112,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     def respawn(self):
         config.pki_log.info(log.CONFIGURATION_RESPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # ALWAYS Restart this Apache/Tomcat PKI Process
+        util.systemd.restart()
         return self.rv
 
     def destroy(self):
@@ -76,23 +123,19 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
                util.instance.apache_instances() == 1:
                 util.directory.delete(master['pki_client_path'])
-                util.symlink.delete(
-                    config.pki_master_dict['pki_systemd_service_link'])
+                util.symlink.delete(master['pki_systemd_service_link'])
             elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
                  util.instance.tomcat_instances() == 1:
                 util.directory.delete(master['pki_client_path'])
-                util.symlink.delete(
-                    config.pki_master_dict['pki_systemd_service_link'])
+                util.symlink.delete(master['pki_systemd_service_link'])
         else:
             # ALWAYS display correct information (even during dry_run)
             if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
                util.instance.apache_instances() == 0:
                 util.directory.delete(master['pki_client_path'])
-                util.symlink.delete(
-                    config.pki_master_dict['pki_systemd_service_link'])
+                util.symlink.delete(master['pki_systemd_service_link'])
             elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
                  util.instance.tomcat_instances() == 0:
                 util.directory.delete(master['pki_client_path'])
-                util.symlink.delete(
-                    config.pki_master_dict['pki_systemd_service_link'])
+                util.symlink.delete(master['pki_systemd_service_link'])
         return self.rv
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/deploy/src/scriptlets/finalization.py
index 02c5065..bceec67 100644
--- a/base/deploy/src/scriptlets/finalization.py
+++ b/base/deploy/src/scriptlets/finalization.py
@@ -100,4 +100,20 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         if not config.pki_dry_run_flag:
             util.file.modify(master['pki_destroy_log'], silent=True)
+        # Start this Apache/Tomcat PKI Process
+        if not config.pki_dry_run_flag:
+            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+               util.instance.apache_instances() >= 1:
+                util.systemd.start()
+            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+                 util.instance.tomcat_instances() >= 1:
+                util.systemd.start()
+        else:
+            # ALWAYS display correct information (even during dry_run)
+            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+               util.instance.apache_instances() >= 0:
+                util.systemd.start()
+            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+                 util.instance.tomcat_instances() >= 0:
+                util.systemd.start()
         return self.rv
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/deploy/src/scriptlets/initialization.py
index 3077737..1ff8522 100644
--- a/base/deploy/src/scriptlets/initialization.py
+++ b/base/deploy/src/scriptlets/initialization.py
@@ -41,9 +41,14 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # verify that this type of "subsystem" does NOT yet
         # exist for this "instance"
         util.instance.verify_subsystem_does_not_exist()
+        # initialize 'uid' and 'gid'
+        util.identity.add_uid_and_gid(master['pki_user'], master['pki_group'])
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
+        # verify existence of MANDATORY configuration file data
+        util.configuration_file.verify_sensitive_data()
+        util.configuration_file.verify_mutually_exclusive_data()
         return self.rv
 
     def respawn(self):
@@ -74,4 +79,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
+        # ALWAYS Stop this Apache/Tomcat PKI Process
+        util.systemd.stop()
         return self.rv
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 8a645f0..2fd7165 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -48,30 +48,90 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             # establish Tomcat instance base
             util.directory.create(master['pki_tomcat_common_path'])
             util.directory.create(master['pki_tomcat_common_lib_path'])
+            util.directory.create(master['pki_tomcat_tmpdir_path'])
             util.directory.create(master['pki_tomcat_webapps_path'])
             util.directory.create(master['pki_tomcat_webapps_root_path'])
             util.directory.create(master['pki_tomcat_webapps_root_webinf_path'])
             util.file.copy(master['pki_source_webapps_root_web_xml'],
                            master['pki_tomcat_webapps_root_webinf_web_xml'],
                            overwrite_flag=True)
-            util.directory.create(master['pki_tomcat_webapps_webinf_path'])
+            util.directory.create(master['pki_tomcat_work_path'])
+            util.directory.create(master['pki_tomcat_work_catalina_path'])
+            util.directory.create(master['pki_tomcat_work_catalina_host_path'])
             util.directory.create(
-                master['pki_tomcat_webapps_webinf_classes_path'])
-            util.directory.create(master['pki_tomcat_webapps_webinf_lib_path'])
+                master['pki_tomcat_work_catalina_host_run_path'])
+            util.directory.create(
+                master['pki_tomcat_work_catalina_host_subsystem_path'])
             # establish Tomcat instance logs
             # establish Tomcat instance configuration
             util.directory.copy(master['pki_source_shared_path'],
                                 master['pki_instance_configuration_path'],
                                 overwrite_flag=True)
             # establish Tomcat instance registry
-            # establish Tomcat instance convenience
-            # symbolic links
+            # establish Tomcat instance convenience symbolic links
             util.symlink.create(master['pki_tomcat_bin_path'],
                                 master['pki_tomcat_bin_link'])
             util.symlink.create(master['pki_tomcat_lib_path'],
                                 master['pki_tomcat_lib_link'])
+            util.symlink.create(master['pki_instance_log4j_properties'],
+                                master['pki_tomcat_lib_log4j_properties_link'],
+                                uid=0, gid=0)
             util.symlink.create(master['pki_tomcat_systemd'],
-                                master['pki_instance_systemd_link'])
+                                master['pki_instance_systemd_link'],
+                                uid=0, gid=0)
+            # establish Tomcat instance common lib jar symbolic links
+            util.symlink.create(master['pki_apache_commons_collections_jar'],
+                master['pki_apache_commons_collections_jar_link'])
+            util.symlink.create(master['pki_apache_commons_lang_jar'],
+                master['pki_apache_commons_lang_jar_link'])
+            util.symlink.create(master['pki_apache_commons_logging_jar'],
+                master['pki_apache_commons_logging_jar_link'])
+            util.symlink.create(master['pki_commons_codec_jar'],
+                master['pki_commons_codec_jar_link'])
+            util.symlink.create(master['pki_httpclient_jar'],
+                master['pki_httpclient_jar_link'])
+            util.symlink.create(master['pki_javassist_jar'],
+                master['pki_javassist_jar_link'])
+            util.symlink.create(master['pki_resteasy_jaxrs_api_jar'],
+                master['pki_resteasy_jaxrs_api_jar_link'])
+            util.symlink.create(master['pki_jettison_jar'],
+                master['pki_jettison_jar_link'])
+            util.symlink.create(master['pki_jss_jar'],
+                master['pki_jss_jar_link'])
+            util.symlink.create(master['pki_ldapjdk_jar'],
+                master['pki_ldapjdk_jar_link'])
+            util.symlink.create(master['pki_certsrv_jar'],
+                master['pki_certsrv_jar_link'])
+            util.symlink.create(master['pki_cmsbundle'],
+                master['pki_cmsbundle_jar_link'])
+            util.symlink.create(master['pki_cmscore'],
+                master['pki_cmscore_jar_link'])
+            util.symlink.create(master['pki_cms'],
+                master['pki_cms_jar_link'])
+            util.symlink.create(master['pki_cmsutil'],
+                master['pki_cmsutil_jar_link'])
+            util.symlink.create(master['pki_nsutil'],
+                master['pki_nsutil_jar_link'])
+            util.symlink.create(master['pki_resteasy_jaxb_provider_jar'],
+                master['pki_resteasy_jaxb_provider_jar_link'])
+            util.symlink.create(master['pki_resteasy_jaxrs_jar'],
+                master['pki_resteasy_jaxrs_jar_link'])
+            util.symlink.create(master['pki_resteasy_jettison_provider_jar'],
+                master['pki_resteasy_jettison_provider_jar_link'])
+            util.symlink.create(master['pki_scannotation_jar'],
+                master['pki_scannotation_jar_link'])
+            util.symlink.create(master['pki_symkey_jar'],
+                master['pki_symkey_jar_link'])
+            util.symlink.create(master['pki_tomcatjss_jar'],
+                master['pki_tomcatjss_jar_link'])
+            util.symlink.create(master['pki_velocity_jar'],
+                master['pki_velocity_jar_link'])
+            util.symlink.create(master['pki_xerces_j2_jar'],
+                master['pki_xerces_j2_jar_link'])
+            util.symlink.create(master['pki_xml_commons_apis_jar'],
+                master['pki_xml_commons_apis_jar_link'])
+            util.symlink.create(master['pki_xml_commons_resolver_jar'],
+                master['pki_xml_commons_resolver_jar_link'])
         # establish shared NSS security databases for this instance
         util.directory.create(master['pki_database_path'])
         # establish instance convenience symbolic links
@@ -106,16 +166,53 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.file.copy(master['pki_source_webapps_root_web_xml'],
                            master['pki_tomcat_webapps_root_webinf_web_xml'],
                            overwrite_flag=True)
-            util.directory.modify(master['pki_tomcat_webapps_webinf_path'])
+            util.directory.modify(master['pki_tomcat_work_path'])
+            util.directory.modify(master['pki_tomcat_work_catalina_path'])
+            util.directory.modify(master['pki_tomcat_work_catalina_host_path'])
+            util.directory.modify(
+                master['pki_tomcat_work_catalina_host_run_path'])
             util.directory.modify(
-                master['pki_tomcat_webapps_webinf_classes_path'])
-            util.directory.modify(master['pki_tomcat_webapps_webinf_lib_path'])
+                master['pki_tomcat_work_catalina_host_subsystem_path'])
             # update Tomcat instance logs
             # update Tomcat instance configuration
             # update Tomcat instance registry
             # update Tomcat instance convenience symbolic links
             util.symlink.modify(master['pki_tomcat_bin_link'])
             util.symlink.modify(master['pki_tomcat_lib_link'])
+            util.symlink.modify(master['pki_tomcat_lib_log4j_properties_link'],
+                                uid=0, gid=0)
+            util.symlink.modify(master['pki_instance_systemd_link'],
+                                uid=0, gid=0)
+            # update Tomcat instance common lib jar symbolic links
+
+            util.symlink.modify(
+                master['pki_apache_commons_collections_jar_link'])
+            util.symlink.modify(master['pki_apache_commons_lang_jar_link'])
+            util.symlink.modify(master['pki_apache_commons_logging_jar_link'])
+            util.symlink.modify(master['pki_commons_codec_jar_link'])
+            util.symlink.modify(master['pki_httpclient_jar_link'])
+            util.symlink.modify(master['pki_javassist_jar_link'])
+            util.symlink.modify(master['pki_resteasy_jaxrs_api_jar_link'])
+            util.symlink.modify(master['pki_jettison_jar_link'])
+            util.symlink.modify(master['pki_jss_jar_link'])
+            util.symlink.modify(master['pki_ldapjdk_jar_link'])
+            util.symlink.modify(master['pki_certsrv_jar_link'])
+            util.symlink.modify(master['pki_cmsbundle_jar_link'])
+            util.symlink.modify(master['pki_cmscore_jar_link'])
+            util.symlink.modify(master['pki_cms_jar_link'])
+            util.symlink.modify(master['pki_cmsutil_jar_link'])
+            util.symlink.modify(master['pki_nsutil_jar_link'])
+            util.symlink.modify(master['pki_resteasy_jaxb_provider_jar_link'])
+            util.symlink.modify(master['pki_resteasy_jaxrs_jar_link'])
+            util.symlink.modify(
+                master['pki_resteasy_jettison_provider_jar_link'])
+            util.symlink.modify(master['pki_scannotation_jar_link'])
+            util.symlink.modify(master['pki_symkey_jar_link'])
+            util.symlink.modify(master['pki_tomcatjss_jar_link'])
+            util.symlink.modify(master['pki_velocity_jar_link'])
+            util.symlink.modify(master['pki_xerces_j2_jar_link'])
+            util.symlink.modify(master['pki_xml_commons_apis_jar_link'])
+            util.symlink.modify(master['pki_xml_commons_resolver_jar_link'])
         # update shared NSS security databases for this instance
         util.directory.modify(master['pki_database_path'])
         # update instance convenience symbolic links
@@ -150,6 +247,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 # remove shared NSS security database path for this instance
                 util.directory.delete(master['pki_database_path'])
                 # remove Tomcat instance configuration
+                util.symlink.delete(
+                    master['pki_tomcat_lib_log4j_properties_link'])
                 util.directory.delete(master['pki_instance_configuration_path'])
                 # remove Tomcat instance registry
                 util.directory.delete(master['pki_instance_type_registry_path'])
@@ -174,6 +273,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 # remove shared NSS security database path for this instance
                 util.directory.delete(master['pki_database_path'])
                 # remove Tomcat instance configuration
+                util.symlink.delete(
+                    master['pki_tomcat_lib_log4j_properties_link'])
                 util.directory.delete(master['pki_instance_configuration_path'])
                 # remove Tomcat instance registry
                 util.directory.delete(master['pki_instance_type_registry_path'])
